/* socket flags */
#define IS_SERVER 1
#define CONNECTED 2
#define CONN_BROKEN 4
#define PL2_IN_GAME 8
#define WAIT_PL2INGAME 16

#ifdef SOCKET
int sock_flags;

#define is_server (sock_flags & IS_SERVER)

const struct invit {
	char user[16];
	char tty[8];
} *invit;

char *tetrom_seq;	/* tetris_2p.c */

void mkinvitfile();
int checkinvit();
void rminvitfile();

/* ttys should be of size 8*n - n strings of length 8 */
int get_2p_ttys(char *ttys, int n);

/* tty is opponent's tty (may be NULL if server).
 * returns malloc'd error message on error, otherwise NULL */
char *mksocket_local(const char *tty, int server);

#ifdef INET
/* makes server socket if name is NULL.
 * prints error message and exits on failure */
void mksocket_inet(const char *name, unsigned port);
#endif

/* exits with error message on failure */
void connect_tty(const char *tty);

void sock_sendbyte(char byte);

void sock_initgame();
void sock_sendplayer();
int sock_wait_pl2ingame();
void sock_initround();

#ifdef tetris_h
void sock_sendnext(const struct player *p, char n);
void sock_sendpiece(const struct player *p);
#endif
void sock_requestgarbage();

int sock_getkeypress(int flags);

void rmsocket();

#else /* ifndef SOCKET */

#define sock_flags 0
#define is_server 1

#define mkinvitfile()
#define rminvitfile()

#define sock_sendbyte(b)
#define sock_initgame()
#define sock_wait_pl2ingame() 0
#define sock_initround()
#define sock_sendpiece(p)
#define sock_requestgarbage()

#define rmsocket()

#endif
